Index: trunk/kernel/libk/grdxt.h
===================================================================
--- trunk/kernel/libk/grdxt.h	(revision 690)
+++ trunk/kernel/libk/grdxt.h	(revision 1)
@@ -1,6 +1,6 @@
 /*
- * grdxt.h - Three-levels Generic Radix-tree definition.
+ * grdxt.h - Three-levels Generic Radix-tree interface
  * 
- * Authors  Alain Greiner (2016,2017,2018,2019,2019,2020)
+ * Authors  Alain Greiner (2016)
  *
  * Copyright  UPMC Sorbonne Universites
@@ -25,5 +25,5 @@
 #define _GRDXT_H_
 
-#include <hal_kernel_types.h>
+#include <hal_types.h>
 
 /*******************************************************************************************
@@ -36,12 +36,6 @@
  * Memory for the second and third levels arrays is dynamically allocated by the
  * grdxt_insert() function and is only released by grdxt_destroy().
- * This structure is entirely contained in one single cluster, but to allow any thread
- * to access it, two sets of access functions are defined:
- * - local threads can use access function using local pointers.
- * - remote threads must use the access functions using extended pointers.
- ******************************************************************************************
- * When it is used by the mapper implementing the file cache:
- * - the key is the page index in file.
- * - the registered value is a local pointer on the page descriptor.
+ * - It used to by the VMM to retrieve a vseg descriptor: key is the virtual address.
+ * - It is used by the mapper to implement the file cache: key is the page index in file.
  ******************************************************************************************/
 
@@ -55,12 +49,8 @@
 grdxt_t;
 
-////////////////////////////////////////////////////////////////////////////////////////////
-//                       Local access functions
-////////////////////////////////////////////////////////////////////////////////////////////
 
 /*******************************************************************************************
  * This function initialises the radix-tree descriptor,
  * and allocates memory for the first level array of pointers.
- * It must be called by a local thread.
  *******************************************************************************************
  * @ rt        : pointer on the radix-tree descriptor.
@@ -77,6 +67,5 @@
 /*******************************************************************************************
  * This function releases all memory allocated to the radix-tree infrastructure.
- * A warning message is printed on the kernel TXT0 if the radix tree is not empty.
- * It must be called by a local thread.
+ * The radix-tree is supposed to be empty, but this is NOT checked by this function.
  *******************************************************************************************
  * @ rt      : pointer on the radix-tree descriptor.
@@ -87,10 +76,9 @@
  * This function insert a new item in the radix-tree.
  * It dynamically allocates memory for new second and third level arrays if required.
- * It must be called by a local thread.
  *******************************************************************************************
  * @ rt      : pointer on the radix-tree descriptor.
  * @ key     : key value.
  * @ value   : pointer on item to be registered in radix-tree.
- * @ returns 0 if success / returns -1 if no memory, or illegal key.
+ * @ returns 0 if success / returns ENOMEM if no memory, or EINVAL if illegal key.
  ******************************************************************************************/
 error_t grdxt_insert( grdxt_t  * rt,
@@ -99,7 +87,6 @@
 
 /*******************************************************************************************
- * This function removes an item identified by its key from the radix tree,
- * and returns a pointer on the removed item. No memory is released.
- * It must be called by a local thread.
+ * This function removes an item identified by its key, and returns a pointer
+ * on the removed item. No memory is released.
  *******************************************************************************************
  * @ rt      : pointer on the radix-tree descriptor.
@@ -111,11 +98,9 @@
 
 /*******************************************************************************************
- * This function returns to a local client, a local pointer on the item identified 
- * It must be called by a local thread.
- * by the <key> argument, from the radix tree identified by the <rt> local pointer.
+ * This function returns the pointer on the item identified by its key.
  *******************************************************************************************
- * @ rt      : local pointer on the radix-tree descriptor.
+ * @ rt      : pointer on the radix-tree descriptor.
  * @ key     : key value.
- * @ returns a local pointer on found item if success / returns NULL if failure.
+ * @ returns pointer on found item if success / returns NULL if failure.
  ******************************************************************************************/
 void * grdxt_lookup( grdxt_t  * rt, 
@@ -124,12 +109,11 @@
 /*******************************************************************************************
  * This function scan all radix-tree entries in increasing key order, starting from
- * the key defined by the <start_key> argument. It returns a pointer on the first valid
- * registered item, and returns in the <found_key> buffer the found item key value.
- * It must be called by a local thread.
+ * the value defined by the <key> argument, and return a pointer on the first valid
+ * registered item, and the found item key value.
  *******************************************************************************************
  * @ rt         : pointer on the radix-tree descriptor.
  * @ start_key  : key starting value for the scan.
  * @ found_key  : [out] buffer for found key value.
- * @ return pointer on first valid item if found / return NULL if no item found.
+ * return pointer on first valid item if found / return NULL if not found.
  ******************************************************************************************/
 void * grdxt_get_first( grdxt_t  * rt,
@@ -137,97 +121,13 @@
                         uint32_t * found_key );
 
-////////////////////////////////////////////////////////////////////////////////////////////
-//                       Remote access functions
-////////////////////////////////////////////////////////////////////////////////////////////
+/*******************************************************************************************
+ * This function displays the content of the radix_tree.
+ *******************************************************************************************
+ * @ rt      : pointer on the radix-tree descriptor.
+ * @ name    : string identifying the radix-tree.
+ ******************************************************************************************/
+void grdxt_print( grdxt_t * rt,
+                  char    * name );
 
-/*******************************************************************************************
- * This function initialises the radix-tree descriptor,
- * and allocates memory for the first level array of pointers.
- * It can be called by any thread running in any cluster
- *******************************************************************************************
- * @ rt_xp     : extended pointer on the radix-tree descriptor.
- * @ ix1_width : number of bits in ix1 field
- * @ ix2_width : number of bits in ix2 field
- * @ ix3_width : number of bits in ix3 field
- * @ returns 0 if success / returns ENOMEM if no more memory.      
- ******************************************************************************************/
-error_t grdxt_remote_init( xptr_t     rt_xp,
-                           uint32_t   ix1_width,
-                           uint32_t   ix2_width,
-                           uint32_t   ix3_width );
-
-/*******************************************************************************************
- * This function releases all memory allocated to the radix-tree infrastructure.
- * A warning message is printed on the kernel TXT0 if the radix tree is not empty.
- * It can be called by any thread running in any cluster
- *******************************************************************************************
- * @ rt_xp    : extended pointer on the radix-tree descriptor.
- ******************************************************************************************/
-void grdxt_remote_destroy( xptr_t  rt_xp );
-
-/*******************************************************************************************
- * This function insert a new item in a - possibly remote - radix tree.
- * It dynamically allocates memory for new second and third level arrays if required.
- * It can be called by any thread running in any cluster
- *******************************************************************************************
- * @ rt_xp   : extended pointer on the radix-tree descriptor.
- * @ key     : key value.
- * @ value   : pointer on item to be registered in radix-tree.
- * @ returns 0 if success / returns -1 if no memory, or illegal key.
- ******************************************************************************************/
-error_t grdxt_remote_insert( xptr_t     rt_xp,
-                             uint32_t   key,
-                             void     * value );
-
-/*******************************************************************************************
- * This function removes an item identified by its key from a - possibly remote - radix
- * tree, and returns a local pointer on the removed item. No memory is released.
- * It can be called by a thread running in any cluster
- *******************************************************************************************
- * @ rt_xp   : pointer on the radix-tree descriptor.
- * @ key     : key value.
- * @ returns extended pointer on removed item if success / returns XPTR_NULL if failure.
- ******************************************************************************************/
-xptr_t grdxt_remote_remove( xptr_t    rt_xp,
-                            uint32_t  key );
-
-/*******************************************************************************************
- * This function returns to a - possibly remote - client, an extended pointer
- * on the item identified by the <key> argument, from the radix tree identified by
- * the <rt_xp> remote pointer.
- * It can be called by a thread running in any cluster
- *******************************************************************************************
- * @ rt_xp   : extended pointer on the radix-tree descriptor.
- * @ key     : key value.
- * @ returns extended pointer on found item if success / returns XPTR_NULL if not found.
- ******************************************************************************************/
-xptr_t grdxt_remote_lookup( xptr_t     rt_xp, 
-                            uint32_t   key );
-
-/*******************************************************************************************
- * This function scan all radix-tree entries of a - possibly remote - radix tree <rt_xp>,
- * in increasing key order, starting from the key defined by the <start_key> argument.
- * It returns an extended pointer on the first valid registered item, and returns in the
- * <found_key> buffer the found item key value.
- * It can be called by a thread running in any cluster
- *******************************************************************************************
- * @ rt_xp      : extended pointer on the radix-tree descriptor.
- * @ start_key  : key starting value for the scan.
- * @ found_key  : [out] buffer for found key value.
- * @ return xptr on first valid item if found / return XPTR_NULL if no item found.
- ******************************************************************************************/
-xptr_t grdxt_remote_get_first( xptr_t     rt_xp,
-                               uint32_t   start_key,
-                               uint32_t * found_key );
-
-/*******************************************************************************************
- * This function displays the current content of a possibly remote radix_tree.
- * It can be called by a thread running in any cluster
- *******************************************************************************************
- * @ rt      : extended pointer on the radix-tree descriptor.
- * @ string  : radix tree identifier. 
- ******************************************************************************************/
-void grdxt_remote_display( xptr_t    rt_xp,
-                           char    * string );
 
 #endif	/* _GRDXT_H_ */
Index: trunk/kernel/libk/htab.c
===================================================================
--- trunk/kernel/libk/htab.c	(revision 690)
+++ trunk/kernel/libk/htab.c	(revision 1)
@@ -2,5 +2,7 @@
  * htable.c - Generic, embedded hash table implementation.
  * 
- * Author      Alain Greiner (2016,2017)
+ * Author     Ghassan Almalles (2008,2009,2010,2011,2012)
+ *            Mohamed Lamine Karaoui (2015)
+ *            Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -8,9 +10,9 @@
  * This file is part of ALMOS-MKH.
  *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-MKH.is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-MKH.is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,191 +20,115 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <hal_special.h>
-#include <htab.h>
-#include <busylock.h>
-#include <list.h>
-#include <printk.h>
-#include <vfs.h>
+#include <htable.h>
+#include <kmem.h>
+#include <ppm.h>
 
+///////////////////////////////////////////////
+error_t ht_header_init( ht_header_t  * header,
+                        ht_hash_t    * hash,
+                        ht_compare_t * compare )
+{
+	uint32_t     i;
+	kmem_req_t   req;
+	page_t     * page;
 
-///////////////////////////////////////////////////////////////////////////////////////////
-//    Item type specific (static) functions (two functions for each item type).
-// Example below if for <bloup_t> type, where the identifier is an uint32_t field. 
-///////////////////////////////////////////////////////////////////////////////////////////
+	req.type  = KMEM_PAGE;
+	req.size  = 0;
+	req.flags = AF_ZERO;
+	page      = kmem_alloc( &req );
+	
+	if( page == NULL ) return ENOMEM;
 
-typedef struct bloup_s
-{
-    uint32_t       key;
-    list_entry_t   list;
-}
-bloup_t;
+	header->nb_buckets = CONFIG_PPM_PAGE_SIZE/sizeof( list_entry_t );
+	header->buckets    = ppm_page2base( page );
+	header->hash       = hash;
+	header->compare    = compare;
 
-///////////////////////////////////////////////////////////////////////////////////////////
-// This static function computes the hash index from the key.
-///////////////////////////////////////////////////////////////////////////////////////////
-// @ key      : local pointer on key.
-// @ return the index value, from 0 to (HASHTAB_SIZE - 1)
-///////////////////////////////////////////////////////////////////////////////////////////
-static uint32_t htab_bloup_index( void * key )
-{
-	return (*(uint32_t *)key) % HASHTAB_SIZE;
+	for( i=0 ; i < header->nb_buckets ; i++ )
+	{
+		list_root_init( &header->buckets[i] );
+	}
+
+	return 0;
 }
 
-///////////////////////////////////////////////////////////////////////////////////////
-// This static function is used by htab_lookup(), htab_insert(), and htab_remove().
-// They scan one sub-list identified by  <index> to find an item  identified by <key>.
-// The sub-list is not modified, but the lock must have been taken by the caller.
-///////////////////////////////////////////////////////////////////////////////////////
-// @ htab    : pointer on hash table.
-// @ index   : index of sub-list to be scanned.
-// @ key     : pointer on item identifier.
-// @ return pointer on item if found / return NULL if not found.
-///////////////////////////////////////////////////////////////////////////////////////
-static void * htab_bloup_scan( htab_t  * htab,
-                               uint32_t  index,
-                               void    * key )
+////////////////////////////////////////
+error_t ht_node_init( ht_node_t * node )
 {
-    list_entry_t * list_entry;   // pointer on list_entry_t (iterator)
-    bloup_t      * bloup;        // pointer on item
-    
-	LIST_FOREACH( &htab->roots[index] , list_entry )
+	node->index = (uint32_t) -1;
+	list_entry_init( &node->list );
+
+	return 0;
+}
+
+/////////////////////////////////////////////////
+static ht_node_t * __hfind( ht_header_t * header,
+                            uint32_t      index,
+                            void        * key)
+{
+	ht_node_t    * node;
+	list_entry_t * root,
+    list_entry_t * iter;
+
+	root = &header->buckets[index % header->nb_buckets];
+
+	LIST_FOREACH( root , iter )
 	{
-        bloup = (bloup_t *)LIST_ELEMENT( list_entry , bloup_t , list );
-        if( bloup->key == *(uint32_t *)key ) return bloup; 
-    }
+		node = LIST_ELEMENT( iter , ht_node_t , list );
+		if( node->index == index )
+		{
+			if( header->compare( node , key ) ) return node;
+		}
+	}
 
-    // no matching item found
 	return NULL;
 }
 
-////////////////////////////////////////////////////////////////////////////////////////
-//         Generic access functions
-////////////////////////////////////////////////////////////////////////////////////////
+//////////////////////////////////////////
+ht_node_t * ht_find( ht_header_t * header,
+                     void        * key )
+{
+	uint32_t index = header->hash( key );
+
+	return __ht_find( header , index , key );
+}
 
 ////////////////////////////////////////
-void htab_init( htab_t           * htab,
-                htab_item_type_t   type )
+error_t ht_insert( ht_header_t * header,
+                   ht_node_t   * node,
+                   void        * key )
 {
-	uint32_t     i;
+	uint32_t index = header->hash( key );
 
-    // initialize readlock
-    busylock_init( &htab->lock , LOCK_HTAB_STATE );
+	ht_node_t * node = __ht_find( header , index , key );
 
-    htab->items = 0;
+	if( node != NULL ) return EINVAL;
 
-    if( type == HTAB_BLOUP_TYPE )
-    {
-        htab->scan    = &htab_bloup_scan;
-        htab->index   = &htab_bloup_index;
-    }
-    else
-    {
-        assert( __FUNCTION__, false , "undefined item type\n" );
-    }
+	list_entry_t * root = &header->buckets[index % header->nb_buckets];
 
-    // initialize partial lists
-    for( i = 0 ; i < HASHTAB_SIZE ; i++ )
-    {
-        list_root_init( &htab->roots[i] );
-    }
+	list_add_first( root , &node->list);
+
+	node->index = index;
+
+	return 0;
 }
 
-/////////////////////////////////////////
-error_t htab_insert( htab_t       * htab, 
-                     void         * key,
-                     list_entry_t * list_entry )
+////////////////////////////////////////
+error_t ht_remove( ht_header_t * header,
+                   void        * key )
 {
-    // compute index from key
-    uint32_t index = htab->index( key );
+	uint32_t index = header->hash( key );
 
-    // take the lock 
-    busylock_acquire( &htab->lock );
+	ht_node_t * node = __ht_find( header , index , key );
 
-    // scan sub-list to check if item exist
-    void * item = htab->scan( htab , index , key );
+	if( node == NULL ) return EINVAL;
 
-    if( item != NULL ) // item exist => return error
-    {
-        // release lock
-        busylock_release( &htab->lock );
+	list_unlink( &node->list );
 
-        return 0xFFFFFFFF;
-    }
-    else               // item doesn't exist => register
-    {
-        // register item in hash table
-        list_add_last( &htab->roots[index] , list_entry );
-
-        // update items number
-        htab->items++;
-
-        // release lock
-        busylock_release( &htab->lock );
-
-        return 0;
-    }
+	return 0;
 }
 
-/////////////////////////////////////////
-error_t htab_remove( htab_t       * htab, 
-                     void         * key,
-                     list_entry_t * list_entry )
-{
-    // compute index from key
-    uint32_t index = htab->index( key );
-
-    // take the lock 
-    busylock_acquire( &htab->lock );
-
-    // scan sub-list to chek if item exist
-    void * item = htab->scan( htab , index , key );
-
-    if( item == NULL ) // item doesn't exist
-    {
-        // release lock
-        busylock_release( &htab->lock );
-
-        return 0xFFFFFFFF;
-    }
-    else               // item exist => remove it 
-    {
-        // remove item from hash table
-        list_unlink( list_entry );
-
-        // update items number
-        htab->items--;
-
-        // release lock
-        busylock_release( &htab->lock );
-
-        return 0;
-    }
-}
-
-//////////////////////////////////
-void * htab_lookup( htab_t * htab, 
-                    void   * key )
-{
-    // compute index from key
-    uint32_t index = htab->index( key );
-
-    // take the lock
-    busylock_acquire( &htab->lock );
-
-    // scan sub-list
-    void * item = htab->scan( htab , index , key );
-
-    // release lock 
-    busylock_release( &htab->lock );
-
-	return item;
-}
-
-
-
